use self::iterator::WrapperIterator;
use crate::Storage;

mod iterator;

pub struct Sled {
    db: sled::Db,
}

impl Sled {
    pub fn new() -> Self {
        Self {
            db: sled::open("my_db").unwrap(),
        }
    }
}

impl<'a> Storage<'a, WrapperIterator<'a>> for Sled {
    fn get_by_filter(
        &'a self,
        query: nostr_rs_types::types::Filter,
    ) -> Result<WrapperIterator<'a>, crate::Error> {
        Ok(WrapperIterator::new(self, query))
    }
}
